package com.ruoyi.learn.domain;

import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 学生错题本对象 learn_wrong_book
 *
 * @author ruoyi
 * @date 2025-09-25
 */
public class LearnWrongBook extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 错题id */
    private Long wrongId;

    /** 学生ID */
    @Excel(name = "学生ID")
    private Long studentId;

    /** 题ID */
    @Excel(name = "题ID")
    private Long questionId;

    /** 最后来源,练习,试卷，刷题 */
    @Excel(name = "最后来源,练习,试卷，刷题")
    private String source;

    /** 最后状态 */
    @Excel(name = "最后状态")
    private Long state;

    /** 知识点id */
    @Excel(name = "知识点id")
    private Long knownledgeId;

    /** 科目 */
    @Excel(name = "科目")
    private Long subjectId;

    /** 试卷id */
    @Excel(name = "试卷id")
    private Long paperId;

    /** 最后参考答案 */
    @Excel(name = "最后参考答案")
    private String answer;

    /** 答案1 */
    @Excel(name = "答案1")
    private String answer1;

    /** 答案2 */
    @Excel(name = "答案2")
    private String answer2;

    /** 总分 */
    @Excel(name = "总分")
    private Integer scoreTotal;

    /** 得分 */
    @Excel(name = "得分")
    private Integer score;

    /** 评级 */
    @Excel(name = "评级")
    private String scoreLevel;

    /** 得分率 */
    @Excel(name = "得分率")
    private Integer scoreRate;

    /** 错误次数 */
    @Excel(name = "错误次数")
    private Long wrongCount;

    /** 正确次数 */
    @Excel(name = "正确次数")
    private Long rightCount;

    /** 总次数 */
    @Excel(name = "总次数")
    private Long totalCount;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createdTime;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date updatedTime;

    /** 是否收藏 */
    @Excel(name = "是否收藏")
    private Long collect;

    private String knownledgeName;
    private String title;
    private String knowledge;
    private String parse;
    @ApiModelProperty("考题类型 question_type")
    Integer typeId;
    @ApiModelProperty("考题类型名称")
    String type;
    @ApiModelProperty("选项数组")
    List<String> options;
    @ApiModelProperty("答案数组")
    List<String> answers;

    public void setWrongId(Long wrongId)
    {
        this.wrongId = wrongId;
    }

    public Long getWrongId()
    {
        return wrongId;
    }

    public void setStudentId(Long studentId)
    {
        this.studentId = studentId;
    }

    public Long getStudentId()
    {
        return studentId;
    }

    public void setQuestionId(Long questionId)
    {
        this.questionId = questionId;
    }

    public Long getQuestionId()
    {
        return questionId;
    }

    public void setSource(String source)
    {
        this.source = source;
    }

    public String getSource()
    {
        return source;
    }

    public void setState(Long state)
    {
        this.state = state;
    }

    public Long getState()
    {
        return state;
    }

    public void setKnownledgeId(Long knownledgeId)
    {
        this.knownledgeId = knownledgeId;
    }

    public Long getKnownledgeId()
    {
        return knownledgeId;
    }

    public void setSubjectId(Long subjectId)
    {
        this.subjectId = subjectId;
    }

    public Long getSubjectId()
    {
        return subjectId;
    }

    public void setPaperId(Long paperId)
    {
        this.paperId = paperId;
    }

    public Long getPaperId()
    {
        return paperId;
    }

    public void setAnswer(String answer)
    {
        this.answer = answer;
    }

    public String getAnswer()
    {
        return answer;
    }

    public void setAnswer1(String answer1)
    {
        this.answer1 = answer1;
    }

    public String getAnswer1()
    {
        return answer1;
    }

    public void setAnswer2(String answer2)
    {
        this.answer2 = answer2;
    }

    public String getAnswer2()
    {
        return answer2;
    }

    public void setScoreTotal(Integer scoreTotal)
    {
        this.scoreTotal = scoreTotal;
    }

    public Integer getScoreTotal()
    {
        return scoreTotal;
    }

    public void setScore(Integer score)
    {
        this.score = score;
    }

    public Integer getScore()
    {
        return score;
    }

    public void setScoreLevel(String scoreLevel)
    {
        this.scoreLevel = scoreLevel;
    }

    public String getScoreLevel()
    {
        return scoreLevel;
    }

    public void setScoreRate(Integer scoreRate)
    {
        this.scoreRate = scoreRate;
    }

    public Integer getScoreRate()
    {
        return scoreRate;
    }

    public void setWrongCount(Long wrongCount)
    {
        this.wrongCount = wrongCount;
    }

    public Long getWrongCount()
    {
        return wrongCount;
    }

    public void setRightCount(Long rightCount)
    {
        this.rightCount = rightCount;
    }

    public Long getRightCount()
    {
        return rightCount;
    }

    public void setTotalCount(Long totalCount)
    {
        this.totalCount = totalCount;
    }

    public Long getTotalCount()
    {
        return totalCount;
    }

    public void setCreatedTime(Date createdTime)
    {
        this.createdTime = createdTime;
    }

    public Date getCreatedTime()
    {
        return createdTime;
    }

    public void setUpdatedTime(Date updatedTime)
    {
        this.updatedTime = updatedTime;
    }

    public Date getUpdatedTime()
    {
        return updatedTime;
    }

    public void setCollect(Long collect)
    {
        this.collect = collect;
    }

    public Long getCollect()
    {
        return collect;
    }

    public String getKnownledgeName() {
        return knownledgeName;
    }

    public void setKnownledgeName(String knownledgeName) {
        this.knownledgeName = knownledgeName;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getKnowledge() {
        return knowledge;
    }

    public void setKnowledge(String knowledge) {
        this.knowledge = knowledge;
    }

    public String getParse() {
        return parse;
    }

    public void setParse(String parse) {
        this.parse = parse;
    }

    public Integer getTypeId() {
        return typeId;
    }

    public void setTypeId(Integer typeId) {
        this.typeId = typeId;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<String> getOptions() {
        return options;
    }

    public void setOptions(List<String> options) {
        this.options = options;
    }

    public List<String> getAnswers() {
        return answers;
    }

    public void setAnswers(List<String> answers) {
        this.answers = answers;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("wrongId", getWrongId())
            .append("studentId", getStudentId())
            .append("questionId", getQuestionId())
            .append("source", getSource())
            .append("state", getState())
            .append("knownledgeId", getKnownledgeId())
            .append("subjectId", getSubjectId())
            .append("paperId", getPaperId())
            .append("answer", getAnswer())
            .append("answer1", getAnswer1())
            .append("answer2", getAnswer2())
            .append("scoreTotal", getScoreTotal())
            .append("score", getScore())
            .append("scoreLevel", getScoreLevel())
            .append("scoreRate", getScoreRate())
            .append("wrongCount", getWrongCount())
            .append("rightCount", getRightCount())
            .append("totalCount", getTotalCount())
            .append("createdTime", getCreatedTime())
            .append("updatedTime", getUpdatedTime())
            .append("collect", getCollect())
            .toString();
    }
}
